<?php
/*
 * Copyright (C) 2010 - PRiSE
 * This class is based on the php library crypt.php developed by RedIRIS
 *
 * This	free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

class Crypt_AES {
	
	public static function encrypt_base64($input, $key) {
 		$td = mcrypt_module_open(MCRYPT_RIJNDAEL_128,'',MCRYPT_MODE_ECB,'');
		$iv = mcrypt_create_iv (mcrypt_enc_get_iv_size($td), MCRYPT_RAND);

		$key = substr($key, 0, mcrypt_enc_get_key_size($td));

		if (mcrypt_generic_init($td, $key, $iv) != -1) {
			// Encrypt the text
			$crypttext = mcrypt_generic($td, $input);
			mcrypt_generic_deinit($td);
		}      

		mcrypt_module_close($td);

		// Encode the encrypted text
		$crypttext = base64_encode($crypttext);

		return $crypttext;
	}

	public static function decrypt_base64($input, $key) {
		// Decode the encrypted text
		$input = base64_decode($input);
  
		$td = mcrypt_module_open(MCRYPT_RIJNDAEL_128,'',MCRYPT_MODE_ECB,'');
		$iv = mcrypt_create_iv (mcrypt_enc_get_iv_size($td), MCRYPT_RAND);

		$key = substr($key, 0, mcrypt_enc_get_key_size($td));

		if (mcrypt_generic_init($td, $key, $iv) != -1) {
			// Decrypt the text
			$decrypttext = mdecrypt_generic($td, $input);
			mcrypt_generic_deinit($td);
		}      
 
		mcrypt_module_close($td);
		$decrypttext = trim ($decrypttext);
  
		return $decrypttext;
	}
	
}

?>
